=== tests/CMakeLists.txt ===
add_subdirectory(unittests)
add_subdirectory(fuzz)
